/*	$NetBSD: promboot.c,v 1.6 1998/02/05 04:57:13 gwr Exp $	*/


#include <sys/param.h>
#include <sys/reboot.h>

#include <machine/mon.h>

#include "stand.h"
#include "libsa.h"

int 	debug = 0;
int 	prom_boothow;
char *	prom_bootfile;
char *  prom_bootargs;
char	prom_bootdev[32];

/*
 * Get useful info from the PROM bootparams struct, i.e.:
 * arg[0] = sd(0,0,0)netbsd
 * arg[1] = -sa
 */

void
prom_get_boot_info()
{
	struct bootparam *bp;
	char	c, *src, *dst;
	int i;

#ifdef	DEBUG
	printf("prom_get_boot_info\n");
#endif

	bp = *romVectorPtr->bootParam;

	if(bp->argPtr[1] != NULL) {
		for(i = 2; (i < 8) && (bp->argPtr[i] != NULL); i++) {
#ifdef DEBUG
			printf("argPtr %d: %s\n", i, bp->argPtr[i]);
#endif
			bp->argPtr[i][-1] = ' ';
		}
#ifdef DEBUG
		printf("args: %s\n", bp->argPtr[1]);
#endif
	}
	prom_bootargs = bp->argPtr[1];

	/* Get device and file names. */
	src = bp->argPtr[0];
	dst = prom_bootdev;
	*dst++ = *src++;
	*dst++ = *src++;
	if (*src == '(') {
		while (*src) {
			c = *src++;
			*dst++ = c;
			if (c == ')')
				break;
		}
		*dst = '\0';
	}
	prom_bootfile = src;

	if (debug) {
		printf("Debug level %d - enter c to continue...", debug);
		/* This will print "\nAbort at ...\n" */
		breakpoint();
	}
}
